"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var INSTR_CONTRACT_NAME = 'instr.ore';
var INSTR_TABLE_NAME = 'tokens';
/* Private */
// NOTE: if the endTime is 0, the instrument is valid forever
function isActive(instrument) {
    var startTime = instrument.start_time;
    var endTime = instrument.end_time;
    var currentTime = Math.floor(Date.now() / 1000);
    return (currentTime > startTime && (currentTime < endTime || endTime === 0));
}
function hasCategory(instrument, category) {
    if (instrument.instrument.instrument_class === category) {
        return true;
    }
    return false;
}
function sortByMintedAt(instruments) {
    // sorts the instruments by minted_at property
    // minted_at represents the time when the instrument is either minted or updated
    instruments.sort(function (a, b) { return a.instrument.minted_at - b.instrument.minted_at; });
    return instruments;
}
function sortByCheapestRight(instruments, rightName) {
    var _this = this;
    // sorts the instruments by the price for the right
    instruments.sort(function (a, b) {
        var rightA = _this.getRight(a, rightName);
        var rightB = _this.getRight(b, rightName);
        return rightA.price_in_cpu - rightB.price_in_cpu;
    });
    return instruments;
}
function getInstruments(params) {
    return __awaiter(this, void 0, void 0, function () {
        var keyType, index, results, lowerBound, upperBound, limit, parameters;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    results = [];
                    lowerBound = 0;
                    upperBound = -1;
                    limit = -1;
                    if (params.key_name === 'owner') {
                        keyType = 'i64';
                        index = 2;
                    }
                    else if (params.key_name === 'instrument_template') {
                        keyType = 'i64';
                        index = 3;
                    }
                    else if (params.key_name === 'instrument_class') {
                        keyType = 'i64';
                        index = 4;
                    }
                    else {
                        // index by instrument_id
                        keyType = 'i64';
                        index = 1;
                    }
                    parameters = __assign(__assign({}, params), { json: true, lower_bound: params.lower_bound || lowerBound, upper_bound: params.upper_bound || upperBound, scope: params.scope || params.code, limit: params.limit || limit, key_type: keyType || 'i64', index_position: index || 1 });
                    return [4 /*yield*/, this.eos.rpc.get_table_rows(parameters)];
                case 1:
                    results = _a.sent();
                    return [2 /*return*/, results.rows];
            }
        });
    });
}
/* Public */
function getAllInstruments() {
    return __awaiter(this, void 0, void 0, function () {
        var instruments;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getInstruments.bind(this)({
                        code: 'instr.ore',
                        table: 'tokens'
                    })];
                case 1:
                    instruments = _a.sent();
                    return [2 /*return*/, instruments];
            }
        });
    });
}
function getRight(instrument, rightName) {
    var _a = instrument.instrument, rights = (_a === void 0 ? {} : _a).rights;
    var right = rights.find(function (rightObject) {
        if (rightObject.right_name === rightName) {
            return rightObject;
        }
        return undefined;
    });
    return right;
}
function findInstruments(oreAccountName, activeOnly, category, rightName) {
    if (activeOnly === void 0) { activeOnly = true; }
    if (category === void 0) { category = undefined; }
    if (rightName === void 0) { rightName = undefined; }
    return __awaiter(this, void 0, void 0, function () {
        var instruments;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getInstruments.bind(this)({
                        code: 'instr.ore',
                        table: 'tokens',
                        lower_bound: oreAccountName,
                        key_name: 'owner'
                    })];
                case 1:
                    instruments = _a.sent();
                    if (activeOnly) {
                        instruments = instruments.filter(function (element) { return isActive(element); });
                    }
                    if (category) {
                        instruments = instruments.filter(function (element) { return hasCategory(element, category); });
                    }
                    if (!rightName) return [3 /*break*/, 3];
                    return [4 /*yield*/, this.getInstrumentsByRight.bind(this)(instruments, rightName)];
                case 2:
                    instruments = _a.sent();
                    _a.label = 3;
                case 3: return [2 /*return*/, instruments];
            }
        });
    });
}
function sortInstruments(instruments, rightName, sortOrder) {
    var _this = this;
    if (sortOrder === void 0) { sortOrder = 'cheapestThenMostRecent'; }
    // sorts the instruments depending on the search criteria :
    // cheapestThenMostRecent - returns the cheapest instrument for the right and if there are more than one with the same price, then returns the latest created/updated instrument
    // mostRecent - returns the latest instrument created/updated for the right
    var sortedInstruments;
    var cheapestInstrument;
    var cheapestPrice;
    var cheapestInstruments;
    switch (sortOrder) {
        case 'cheapestThenMostRecent':
            sortedInstruments = sortByCheapestRight.bind(this)(instruments, rightName);
            cheapestInstrument = sortedInstruments[0];
            cheapestPrice = this.getRight(cheapestInstrument, rightName).price_in_cpu;
            cheapestInstruments = sortedInstruments.filter(function (instrument) { return _this.getRight(instrument, rightName).price_in_cpu === cheapestPrice; });
            sortedInstruments = sortByMintedAt(cheapestInstruments);
            break;
        case 'mostRecent':
            sortedInstruments = sortByMintedAt(instruments);
            break;
        default:
            break;
    }
    return sortedInstruments[sortedInstruments.length - 1];
}
module.exports = {
    getRight: getRight,
    getAllInstruments: getAllInstruments,
    findInstruments: findInstruments,
    sortInstruments: sortInstruments
};
//# sourceMappingURL=instrument.js.map