"use strict";
var CONTRACT_NAME = 'eosio.token';
var ORE_ORE_ACCOUNT_NAME = 'eosio';
var TOKEN_SYMBOL = 'ORE';
var amount;
/* Public */
function issueOre(toAccountName, oreAmount, memo) {
    if (memo === void 0) { memo = ''; }
    amount = this.getAmount(oreAmount, TOKEN_SYMBOL);
    return this.issueToken(toAccountName, amount, ORE_ORE_ACCOUNT_NAME, CONTRACT_NAME, memo);
}
function getOreBalance(oreAccountName) {
    return this.getBalance(oreAccountName, TOKEN_SYMBOL, CONTRACT_NAME);
}
function transferOre(fromAccountName, toAccountName, oreAmount, memo) {
    if (memo === void 0) { memo = ''; }
    amount = this.getAmount(oreAmount, TOKEN_SYMBOL);
    return this.transferToken(fromAccountName, toAccountName, amount, CONTRACT_NAME, memo);
}
module.exports = {
    issueOre: issueOre,
    getOreBalance: getOreBalance,
    transferOre: transferOre
};
//# sourceMappingURL=ore.js.map